
function ViewMgrSetVMLLocation(pageID, shapeID, pinX, pinY)
{
	doc = parent.frmDrawing.document;
	if (this.highlightDiv != null)
	{
		clickMenu ();

		var VMLImage = this.s;

		var imageLeft = 0;
		var imageRight = imageLeft + VMLImage.pixelWidth;
		var imageTop = 0;
		var imageBottom = imageTop + VMLImage.pixelHeight;

		var xLong = parent.ConvertXorYCoordinate(pinX, this.visBBoxLeft, this.visBBoxRight, imageLeft, imageRight, 0);
		var yLong = parent.ConvertXorYCoordinate(pinY, this.visBBoxBottom, this.visBBoxTop, imageTop, imageBottom, 1);

		xLong += doc.all['ConvertedImage'].style.posLeft;
		yLong += doc.all['ConvertedImage'].style.posTop;

		var arrowHalfWidth = viewMgr.highlightDiv.clientWidth / 2;
		var arrowHeight = viewMgr.highlightDiv.clientHeight;

		var boolNeedToScroll = false;

		if( !( (xLong - arrowHalfWidth) > doc.body.scrollLeft && (xLong + arrowHalfWidth) < (doc.body.scrollLeft + doc.body.clientWidth) ))
		{
			boolNeedToScroll = true;
		}
		
		if( !( (yLong - arrowHeight) > doc.body.scrollTop && (yLong + arrowHeight) < (doc.body.scrollTop + doc.body.clientHeight) ))
		{
			boolNeedToScroll = true;
		}
		
		if( boolNeedToScroll == true )
		{
			window.scrollTo( xLong - doc.body.clientWidth / 2, yLong - doc.body.clientHeight / 2);
		}
		
		this.highlightDiv.style.posLeft = xLong - arrowHalfWidth;
		this.highlightDiv.style.posTop = yLong;
		this.highlightDiv.style.visibility = "visible";

		setTimeout( "parent.hideObject(viewMgr.highlightDiv)", 0 );
		setTimeout( "parent.showObject(viewMgr.highlightDiv)", 1 );
		setTimeout( "parent.hideObject(viewMgr.highlightDiv)", 2500 );
	}
}

function VMLZoomChange(size)
{
	if(size)
	{
		if(size == "up")
		{
			size = zoomLast + 50;
		}
		else if(size == "down")
		{
			size = zoomLast - 50;
		}
		
		size = parseInt(size);
		if(typeof(size) != "number")
			size = 100;
	}
	else
	{
		size = 100;
	}

	clickMenu ();

	viewMgr.zoomLast = size;

	var zoomFactor = size/100;

	var width = this.s.pixelWidth;
	var height = this.s.pixelHeight;

	var margin = parseInt(document.body.style.margin) * 2;

	var clientWidth = document.body.clientWidth;
	var clientHeight = document.body.clientHeight;

	var newScrollLeft = document.body.scrollLeft;
	var newScrollTop = document.body.scrollTop;

	var winwidth = clientWidth - margin;
	var winheight = clientHeight - margin;

	var widthRatio = winwidth / width;
	var heightRatio = winheight / height;

	if (widthRatio < heightRatio)
	{
		width = zoomFactor * winwidth;
		height = width / this.origWH;
	}
	else
	{
		height = zoomFactor * winheight;
		width = height * this.origWH;
	}

	this.s.pixelWidth = Math.max(width,1);
	this.s.pixelHeight = Math.max(height,1);

	this.sizeLast = size;

	var centerX = (zoomFactor / viewMgr.zoomFactor) * (newScrollLeft + (clientWidth / 2) - this.s.posLeft);
	var centerY = (zoomFactor / viewMgr.zoomFactor) * (newScrollTop + (clientHeight / 2) - this.s.posTop);

	viewMgr.zoomFactor = zoomFactor;

	if (width <= clientWidth)
	{
		this.s.posLeft = Math.max( 0, (clientWidth / 2) - (width / 2));
	}
	else
	{
		var left = centerX - (clientWidth / 2);
		if ( left >= 0 )
		{
			this.s.posLeft = 0;
			newScrollLeft = left;
		}
		else
		{
			this.s.posLeft = -left;
			newScrollLeft = 0;
		}
	}

	if (height <= clientHeight)
	{
		this.s.posTop = Math.max( 0, (clientHeight / 2) - (height / 2));
	}
	else
	{
		var top = centerY - (clientHeight / 2);
		if ( top >= 0 )
		{
			this.s.posTop = 0;
			newScrollTop = top;
		}
		else
		{
			this.s.posTop = -top;
			newScrollTop = 0;
		}
	}

	window.scrollTo(newScrollLeft, newScrollTop);

	this.s.visibility = "visible";

	var newXOffsetPercent = document.body.scrollLeft / this.s.pixelWidth;
	var newYOffsetPercent = document.body.scrollTop / this.s.pixelHeight;
	var newWidthPercent = document.body.clientWidth / this.s.pixelWidth;
	var newHeightPercent = document.body.clientHeight / this.s.pixelHeight;

	if (viewMgr.viewChanged)
	{
		viewMgr.viewChanged (newXOffsetPercent, newYOffsetPercent, newWidthPercent, newHeightPercent);
	}

	if (viewMgr.PostZoomProcessing)
	{
		viewMgr.PostZoomProcessing(size);
	}
}

function VMLSetView (xOffsetPercent, yOffsetPercent)
{
	var leftPixelOffset = xOffsetPercent * this.s.pixelWidth;
	var topPixelOffset = yOffsetPercent * this.s.pixelHeight;

	window.scrollTo (leftPixelOffset - this.s.posLeft, topPixelOffset - this.s.posTop);

	if (viewMgr.PostSetViewProcessing)
	{
		viewMgr.PostSetViewProcessing();
	}
}

function VMLOnResize ()
{
	if (viewMgr.zoomLast == 100)
	{
		viewMgr.Zoom(100);
	}

	if (viewMgr.viewChanged)
	{
		var image = document.all['ConvertedImage'];

		var newWidthPercent = document.body.clientWidth / image.style.pixelWidth;
		var newHeightPercent = document.body.clientHeight / image.style.pixelHeight;

		viewMgr.viewChanged (null, null, newWidthPercent, newHeightPercent);
	}
}

function VMLOnScroll ()
{
	if (viewMgr.viewChanged)
	{
		var image = document.all['ConvertedImage'];

		var newXOffsetPercent = document.body.scrollLeft / image.style.pixelWidth;
		var newYOffsetPercent = document.body.scrollTop / image.style.pixelHeight;

		viewMgr.viewChanged (newXOffsetPercent, newYOffsetPercent, null, null);
	}
}







 

 // CUSTOMIZED CODE
 

//var XMLfolder = "TxBPE8_files/XML/" ; 
var xmlInitLocn = parent.xmlInitLocn ;
var thisFilename = parent.getFileName(window.location) ;
var PageParam = window.location.search ;

//alert(thisFilename) ;

if (thisFilename != "vml_1.htm" && PageParam.indexOf("ComeFrom") < 0 ) {
   // adjustModel(thisFilename,parent.xmlInitLocn);
    loadInitLocation() ;
    if (typeof(parent.oLinks) != "object")   parent.loadXmlLinks() ;
} 
 
 function loadInitLocation() {
    //alert("asdf") ;
    if (typeof(xmlInitLocn) == "object") {
        getXmlInitLocn(xmlInitLocn)
       // alert('xmlInitLocn = obj') ; 
    }
    else {
       // alert('xmlInitLocn != obj') ; 
        var XMLfolder = "XML/" ;
        window.setTimeout(function () {
                          //  xmlInitLocn = XMLData(XMLfolder + "InitialLocation.xml");
                             loadXMLFile(XMLfolder + "InitialLocation.xml",getXmlInitLocn);
                         }    
                      ,10);
    }
}


 function getXmlInitLocn(oRoot) {
      // alert(oRoot.selectSingleNode("SubModel/ZoomLevel").text) ;
        parent.xmlInitLocn =  oRoot ;
       // alert(parent.xmlInitLocn); 
        adjustModel(thisFilename,oRoot); 
        parent.DefaultData = oRoot.getElementsByTagName("DefaultData") ;
        //alert(parent.DefaultData) ; 
    }
    
    
function adjustModel(thisFilename,oRoot) {
   // var oRoot2, ZoomDelay  , ScrollDelay,ZoomLevel , thisFilename, subModel, modelInd, DefaultData  ;
     var oRoot2, ZoomDelay  , ScrollDelay,ZoomLevel , subModel, modelInd, DefaultData  ;
     
    var modelInd, ScrollX, ScrollY  ;
    
    ScrollX = 0 ; ScrollY = 0  ;
    ZoomLevel = 0 ;
    ZoomDelay = 100 ; ScrollDelay = 100 ;
   //oRoot = parent.xmlInitLocn ; 
    
    try {
        //.documentElement ;
        try {
            
            DefaultData = oRoot.getElementsByTagName("DefaultData") ;
    
            ZoomLevel = oRoot.selectSingleNode("DefaultData/ZoomLevel").text ; 
            ZoomDelay = oRoot.selectSingleNode("DefaultData/ZoomDelay").text;  
            ScrollDelay = oRoot.selectSingleNode("DefaultData/ScrollDelay").text;
            ScrollX = oRoot.selectSingleNode("DefaultData/ScrollX").text;
            ScrollY = oRoot.selectSingleNode("DefaultData/ScrollY").text;
            
          // alert(ZoomLevel + " " + ScrollX + " " + ScrollY) ;
        
        }
        catch(e) { alert("DefaultData " + e) ; } 
        
   
        subModel = oRoot.getElementsByTagName("SubModel") ;
        modelInd = -1   ; 
     
       
        for (var i = 0; i < subModel.length; i++ ) {
            if (subModel[i].getAttribute("fileName") == thisFilename) {
                modelInd = i ;
                break ;
            }
        }
    
      
        if (modelInd >= 0) {
            try {
                ZoomLevel = subModel[modelInd].selectSingleNode("ZoomLevel").text;
                //alert(zoomLv) ; 
                ScrollX = subModel[modelInd].selectSingleNode("ScrollX").text ;
                ScrollY = subModel[modelInd].selectSingleNode("ScrollY").text ;
            }
            catch(e) {
                alert("get Zoom, Scroll : " + e) ;
            }
            
            try {
                ZoomDelay = subModel[modelInd].selectSingleNode("ZoomDelay").text ;
                ScrollDelay = subModel[modelInd].selectSingleNode("ScrollDelay").text ;
            }
            catch(e) { 
                //alert(ZoomLevel + " " + ScrollDelay) ;   
            }
     
            customZoom(ZoomLevel,ScrollX,ScrollY,ZoomDelay,ScrollDelay ) ; 
        }  
    
    }
    catch(e) { alert ("adjustModel: " + e); }  
    
        
    
}
    
 function customZoom(zoomLevelId,scrollX, scrollY, ZoomDelay,ScrollDelay  ) {  // by Jerry Le
        	   // alert(scrollX + " " + scrollY ) ; 
		        var zoomLevel = parent.frmToolbar.document.all(zoomLevelId);
		        
		       window.setTimeout(function () {
		                            zoomLevel.click(); 
		                           }  
		                         ,ZoomDelay);
		                         
		                         
		       window.setTimeout(function () {
		                           window.scrollTo(scrollX,scrollY) ; 
		                           
		                           }  
		                         ,ScrollDelay);
		                         
		                   //      window.scrollTop = 100;
        	 
	    }
	    
	    
	  //  alert("In vml_1.js") ; 
	
	    
	    

function createDocument() {
            var aVersions = [ "MSXML2.DOMDocument.5.0",
                "MSXML2.DOMDocument.4.0","MSXML2.DOMDocument.3.0",
                "MSXML2.DOMDocument","Microsoft.XmlDom"
            ];
	
            for (var i = 0; i < aVersions.length; i++) {
                try {
                    var oXmlDom = new ActiveXObject(aVersions[i]);
                    return oXmlDom;
                } catch (oError) {
                    //Do nothing
                }	
            }
            throw new Error("MSXML is not installed.");
        }
        
        
        function loadXMLFile(FileName, requestHandler ) {
            var oXmlDom = createDocument();
            oXmlDom.onreadystatechange = function () {
                if (oXmlDom.readyState == 4 ) {
                    if (oXmlDom.parseError.errorCode == 0) {

                        if (requestHandler) requestHandler(oXmlDom.documentElement) ; 
                        
                    } else {
                        alert("An Error Occurred: " + oXmlDom.parseError.reason);
                    }
                }
            };
            oXmlDom.load(FileName);
        }
        
     